Index: trunk/paper/sourceCode/performances_size.C
===================================================================
--- trunk/paper/sourceCode/performances_size.C	(revision 207)
+++ trunk/paper/sourceCode/performances_size.C	(revision 207)
@@ -0,0 +1,89 @@
+{
+//=========Macro generated from canvas: c1/c1
+//=========  (Mon Jan 26 21:37:50 2009) by ROOT version5.18/00
+   TCanvas *c1 = new TCanvas("c1", "c1",4,27,600,600);
+   gStyle->SetOptStat(0);
+   c1->Range(-5.097561,-123.1171,55.26829,1324.322);
+   c1->SetFillColor(0);
+   c1->SetBorderMode(0);
+   c1->SetBorderSize(2);
+   c1->SetTickx();
+   c1->SetTicky();
+   c1->SetLeftMargin(0.13);
+   c1->SetRightMargin(0.05);
+   c1->SetTopMargin(0.05);
+   c1->SetBottomMargin(0.13);
+   c1->SetFrameFillStyle(0);
+   c1->SetFrameBorderMode(0);
+   c1->SetFrameFillStyle(0);
+   c1->SetFrameBorderMode(0);
+   
+   TMultiGraph *multigraph = new TMultiGraph();
+   multigraph->SetName("");
+   multigraph->SetTitle("");
+   
+   TGraph *graph = new TGraph(6);
+   graph->SetName("Graph");
+   graph->SetTitle("Graph");
+   graph->SetFillColor(1);
+   graph->SetMarkerStyle(21);
+   graph->SetPoint(0,5,119);
+   graph->SetPoint(1,10,236);
+   graph->SetPoint(2,20,496);
+   graph->SetPoint(3,30,702);
+   graph->SetPoint(4,40,936);
+   graph->SetPoint(5,50,1198);
+   
+   TF1 *fit = new TF1("fit","[0]+[1]*x",5,50);
+   fit->SetFillColor(19);
+   fit->SetFillStyle(0);
+   fit->SetMarkerStyle(20);
+   fit->SetLineWidth(1);
+   fit->SetLineStyle(2);
+   fit->SetChisquare(848.7014);
+   fit->GetXaxis()->SetLabelFont(42);
+   fit->GetXaxis()->SetLabelOffset(0.007);
+   fit->GetXaxis()->SetTitleSize(0.05);
+   fit->GetXaxis()->SetTitleOffset(0.9);
+   fit->GetXaxis()->SetTitleFont(42);
+   fit->GetYaxis()->SetLabelFont(42);
+   fit->GetYaxis()->SetLabelOffset(0.007);
+   fit->GetYaxis()->SetTitleSize(0.05);
+   fit->GetYaxis()->SetTitleOffset(1.05);
+   fit->GetYaxis()->SetTitleFont(42);
+   fit->SetParameter(0,2.526027);
+   fit->SetParError(0,13.0878);
+   fit->SetParLimits(0,0,0);
+   fit->SetParameter(1,23.68932);
+   fit->SetParError(1,0.4312966);
+   fit->SetParLimits(1,0,0);
+   graph->GetListOfFunctions()->Add(fit);
+   multigraph->Add(graph,"P");
+   multigraph->Draw("A");
+   multigraph->GetXaxis()->SetTitle("N (kevts)");
+   multigraph->GetXaxis()->SetLabelFont(42);
+   multigraph->GetXaxis()->SetLabelOffset(0.007);
+   multigraph->GetXaxis()->SetTitleSize(0.05);
+   multigraph->GetXaxis()->SetTitleOffset(0.9);
+   multigraph->GetXaxis()->SetTitleFont(42);
+   multigraph->GetYaxis()->SetTitle("File size(MB)");
+   multigraph->GetYaxis()->SetLabelFont(42);
+   multigraph->GetYaxis()->SetLabelOffset(0.007);
+   multigraph->GetYaxis()->SetTitleSize(0.05);
+   multigraph->GetYaxis()->SetTitleOffset(1.31);
+   multigraph->GetYaxis()->SetTitleFont(42);
+   
+   TPaveText *pt = new TPaveText(5,944,35,1200,"r");
+   pt->SetBorderSize(0);
+   pt->SetFillColor(19);
+   pt->SetFillStyle(0);
+   pt->SetTextAlign(12);
+   pt->SetTextFont(42);
+   TText *text = pt->AddText("Delphes performances");
+   text = pt->AddText("1 kevts in 23.69 MB");
+   text = pt->AddText("pp #rightarrow t #bar{t} X");
+   pt->Draw();
+   c1->Modified();
+   c1->cd();
+   c1->SetSelected(c1);
+}
Index: trunk/paper/sourceCode/performances_speed.C
===================================================================
--- trunk/paper/sourceCode/performances_speed.C	(revision 207)
+++ trunk/paper/sourceCode/performances_speed.C	(revision 207)
@@ -0,0 +1,125 @@
+{
+//=========Macro generated from canvas: c1/c1
+//=========  (Mon Jan 26 21:40:59 2009) by ROOT version5.18/00
+   TCanvas *c1 = new TCanvas("c1", "c1",4,27,600,600);
+   gStyle->SetOptStat(0);
+   c1->Range(-5.097561,-80.25091,55.26829,668.5915);
+   c1->SetFillColor(0);
+   c1->SetBorderMode(0);
+   c1->SetBorderSize(2);
+   c1->SetTickx();
+   c1->SetTicky();
+   c1->SetLeftMargin(0.13);
+   c1->SetRightMargin(0.05);
+   c1->SetTopMargin(0.05);
+   c1->SetBottomMargin(0.13);
+   c1->SetFrameFillStyle(0);
+   c1->SetFrameBorderMode(0);
+   c1->SetFrameFillStyle(0);
+   c1->SetFrameBorderMode(0);
+   
+   TMultiGraph *multigraph = new TMultiGraph();
+   multigraph->SetName("");
+   multigraph->SetTitle("");
+   
+   TGraph *graph = new TGraph(6);
+   graph->SetName("Graph");
+   graph->SetTitle("Graph");
+   graph->SetFillColor(1);
+   graph->SetMarkerStyle(20);
+   graph->SetPoint(0,5,60.44);
+   graph->SetPoint(1,10,124.74);
+   graph->SetPoint(2,20,239.38);
+   graph->SetPoint(3,30,376.08);
+   graph->SetPoint(4,40,499.34);
+   graph->SetPoint(5,50,603.238);
+   
+   TF1 *fit = new TF1("fit","[0]+[1]*x",5,50);
+   fit->SetFillColor(19);
+   fit->SetFillStyle(0);
+   fit->SetMarkerStyle(20);
+   fit->SetLineWidth(1);
+   fit->SetLineStyle(2);
+   fit->SetChisquare(279.4312);
+   fit->GetXaxis()->SetLabelFont(42);
+   fit->GetXaxis()->SetLabelOffset(0.007);
+   fit->GetXaxis()->SetTitleSize(0.05);
+   fit->GetXaxis()->SetTitleOffset(0.9);
+   fit->GetXaxis()->SetTitleFont(42);
+   fit->GetYaxis()->SetLabelFont(42);
+   fit->GetYaxis()->SetLabelOffset(0.007);
+   fit->GetYaxis()->SetTitleSize(0.05);
+   fit->GetYaxis()->SetTitleOffset(1.05);
+   fit->GetYaxis()->SetTitleFont(42);
+   fit->SetParameter(0,1.450848);
+   fit->SetParError(0,7.509767);
+   fit->SetParLimits(0,0,0);
+   fit->SetParameter(1,12.22266);
+   fit->SetParError(1,0.2474776);
+   fit->SetParLimits(1,0,0);
+   graph->GetListOfFunctions()->Add(fit);
+   multigraph->Add(graph,"P");
+   
+   graph = new TGraph(6);
+   graph->SetName("Graph");
+   graph->SetTitle("Graph");
+   graph->SetFillColor(1);
+   graph->SetMarkerStyle(24);
+   graph->SetPoint(0,5,45.01);
+   graph->SetPoint(1,10,93.25);
+   graph->SetPoint(2,20,177.34);
+   graph->SetPoint(3,30,280.6);
+   graph->SetPoint(4,40,369.97);
+   graph->SetPoint(5,50,444.52);
+   multigraph->Add(graph,"P");
+   multigraph->Draw("A");
+   multigraph->GetXaxis()->SetTitle("N (kevts)");
+   multigraph->GetXaxis()->SetLabelFont(42);
+   multigraph->GetXaxis()->SetLabelOffset(0.007);
+   multigraph->GetXaxis()->SetTitleSize(0.05);
+   multigraph->GetXaxis()->SetTitleOffset(0.9);
+   multigraph->GetXaxis()->SetTitleFont(42);
+   multigraph->GetYaxis()->SetTitle("CPU time(s)");
+   multigraph->GetYaxis()->SetLabelFont(42);
+   multigraph->GetYaxis()->SetLabelOffset(0.007);
+   multigraph->GetYaxis()->SetTitleSize(0.05);
+   multigraph->GetYaxis()->SetTitleOffset(1.21);
+   multigraph->GetYaxis()->SetTitleFont(42);
+   
+   TPaveText *pt = new TPaveText(5,472,35,600,"r");
+   pt->SetBorderSize(0);
+   pt->SetFillColor(19);
+   pt->SetFillStyle(0);
+   pt->SetTextAlign(12);
+   pt->SetTextFont(42);
+   TText *text = pt->AddText("Delphes performances");
+   text = pt->AddText("1 kevts in 12.22 s");
+   text = pt->AddText("pp #rightarrow t #bar{t} X");
+   pt->Draw();
+   
+   TLegend *leg = new TLegend(0.6,0.2,0.9,0.4,NULL,"brNDC");
+   leg->SetBorderSize(0);
+   leg->SetLineColor(1);
+   leg->SetLineStyle(1);
+   leg->SetLineWidth(1);
+   leg->SetFillColor(19);
+   leg->SetFillStyle(0);
+   TLegendEntry *entry=leg->AddEntry("Graph","General","p");
+   entry->SetLineColor(1);
+   entry->SetLineStyle(1);
+   entry->SetLineWidth(1);
+   entry->SetMarkerColor(1);
+   entry->SetMarkerStyle(20);
+   entry->SetMarkerSize(1);
+   entry=leg->AddEntry("Graph","Event loop only","p");
+   entry->SetLineColor(1);
+   entry->SetLineStyle(1);
+   entry->SetLineWidth(1);
+   entry->SetMarkerColor(1);
+   entry->SetMarkerStyle(24);
+   entry->SetMarkerSize(1);
+   leg->Draw();
+   c1->Modified();
+   c1->cd();
+   c1->SetSelected(c1);
+}