Index: /trunk/paper/notes.tex
===================================================================
--- /trunk/paper/notes.tex	(revision 207)
+++ /trunk/paper/notes.tex	(revision 208)
@@ -121,5 +121,5 @@
 %The simulation package proceeds in two stages. The first part is executed on the generated events. ``Particle-level" informations are read from input files and stored in a {\it \textsc{gen}} \textsc{root} tree. 
 
-Three formats of input files can be used as input in \textsc{Delphes}\footnote{\texttt{[code] }See the \texttt{HEPEVTConverter}, \texttt{LHEFConverter} and \texttt{STDHEPConverter} classes.}. In order to process events from many different generators, the standard Monte Carlo event structure \texttt{StdHEP}~\cite{bib:stdhep} can be used as an input. Besides, \textsc{Delphes} can also provide detector response for events read in ``Les Houches Event Format'' (\textsc{lhef}) and \textsc{root} files obtained using the \texttt{h2root} utility from the \textsc{root} framework~\cite{bib:Root}. 
+Three formats of input files can be used as input in \textsc{Delphes}\footnote{\texttt{[code] }See the \texttt{HEPEVTConverter}, \texttt{LHEFConverter} and \texttt{STDHEPConverter} classes.}. In order to process events from many different generators, the standard Monte Carlo event structure \texttt{StdHEP}~\cite{bib:stdhep} can be used as an input. Besides, \textsc{Delphes} can also provide detector response for events read in ``Les Houches Event Format'' (\textsc{lhef}~\cite{bib:lhe}) and \textsc{root} files obtained using the \texttt{h2root} utility from the \textsc{root} framework~\cite{bib:Root}. 
 %Afterwards, \textsc{Delphes} performs a simple trigger simulation and reconstruct "high-level objects". These informations are organised in classes and each objects are ordered with respect to the transverse momentum. 
 
@@ -747,11 +747,12 @@
 \bibitem{bib:Delphes} \textsc{Delphes}, \href{http://www.fynu.ucl.ac.be/delphes.html}{www.fynu.ucl.ac.be/delphes.html}
 %hepforge:
-\cite{bib:stdhep} http://cepa.fnal.gov/psm/stdhep/c++/ 
+\bibitem{bib:stdhep} L.A. Garren, M. Fischler, \\ \href{http://cepa.fnal.gov/psm/stdhep/c++}{cepa.fnal.gov/psm/stdhep/c++}
+\bibitem{bib:lhe} J. Alwall, et al., \textbf{Comput. Phys. Commun.} \href{http://dx.doi.org/10.1016/j.cpc.2006.11.010}{176:300-304,2007}.
 \bibitem{bib:Root} %\textsc{Root}, \textit{An Object Oriented Data Analysis Framework}, 
 R. Brun, F. Rademakers, Nucl. Inst. \& Meth. in \textbf{Phys. Res. A} \href{http://dx.doi.org/10.1016/S0168-9002(97)00048-X}{389 (1997) 81-86}.
 \bibitem{bib:ExRootAnalysis} %\textit{The} \textsc{ExRootAnalysis} \textit{analysis steering utility}, 
 P. Demin, (2006), unpublished. Now part of \textsc{MadGraph/MadEvent}.
-\bibitem{bib:cmsjetresolution} CMS Collaboration, \textbf{CERN/LHCC} \href{http://documents.cern.ch/cgi-bin/setlink?base=lhcc&categ=public&id=lhcc-2006-001}{2006-001}.
-\bibitem{bib:ATLASresolution} The ATLAS Collaboration, \href{http://arxiv.org/abs/arxiv:0901.0512}{arXiv:hep-ex/0901.0512v1}.
+\bibitem{bib:cmsjetresolution} The CMS Collaboration, \textbf{CERN/LHCC} \\ \href{http://documents.cern.ch/cgi-bin/setlink?base=lhcc&categ=public&id=lhcc-2006-001}{2006-001}.
+\bibitem{bib:ATLASresolution} The ATLAS Collaboration, \\ arXiv:\href{http://arxiv.org/abs/arxiv:0901.0512}{0901.0512v1}[hep-ex].
 \bibitem{bib:Hector} %\textsc{Hector}, \textit{a fast simulator for the transport of particles in beamlines}, 
 X. Rouby, J. de Favereau, K. Piotrzkowski, \textbf{JINST} \href{http://www.iop.org/EJ/abstract/1748-0221/2/09/P09005}{2 P09005 (2007)}.
@@ -761,9 +762,9 @@
 F. Abe et al. (CDF Coll.), \textbf{Phys. Rev. D} \href{http://link.aps.org/doi/10.1103/PhysRevD.45.1448}{45 (1992) 1448}.
 \bibitem{bib:midpoint} %Run II Jet Physics: Proceedings of the Run II QCD and Weak Boson Physics Workshop,
-G.C. Blazey, et al., \href{http://arxiv.org/abs/hep-ex/0005012}{arXiv:hep-ex/0005012}.
+G.C. Blazey, et al., arXiv:\href{http://arxiv.org/abs/hep-ex/0005012}{0005012}[hep-ex].
 \bibitem{bib:SIScone} %\textsc{SIScone}, \textit{A practical Seedless Infrared-Safe Cone jet algorithm}, 
 G.P. Salam, G. Soyez, \textbf{JHEP} \href{http://dx.doi.org/10.1088/1126-6708/2007/05/086}{05 (2007) 086}.
 \bibitem{bib:ktjet} S. Catani, Y.L. Dokshitzer, M.H. Seymour, B.R. Webber, \textbf{Nucl. Phys. B} \href{http://dx.doi.org/10.1016/0550-3213(93)90166-M}{406 (1993) 187}; S.D. Ellis, D.E. Soper, \textbf{Phys. Rev. D} \href{http://link.aps.org/doi/10.1103/PhysRevD.48.3160}{48 (1993) 3160}.
-\bibitem{bib:aachen} Y.L. Dokshitzer, G.D. Leder, S. Moretti, B.R. Webber, \textbf{JHEP} \href{http://dx.doi.org/10.1088/1126-6708/1998/01/011}{08} \href{http://dx.doi.org/10.1088/1126-6708/1998/01/011}{(1997) 001}; M. Wobisch, T. Wengler, \href{http://arxiv.org/abs/hep-ph/9907280}{arXiv:hep-ph/9907280}.
+\bibitem{bib:aachen} Y.L. Dokshitzer, G.D. Leder, S. Moretti, B.R. Webber, \textbf{JHEP} \href{http://dx.doi.org/10.1088/1126-6708/1998/01/011}{08} \href{http://dx.doi.org/10.1088/1126-6708/1998/01/011}{(1997) 001}; M. Wobisch, T. Wengler, arXiv:\href{http://arxiv.org/abs/hep-ph/9907280}{9907280}[hep-ph].
 \bibitem{bib:antikt} %\textit{The anti-kt jet clustering algorithm}, 
 M. Cacciari, G.P. Salam, G. Soyez, \textbf{JHEP} \href{http://dx.doi.org/10.1088/1126-6708/2008/04/063}{04 (2008) 063}.
@@ -776,10 +777,10 @@
 \bibitem{bib:cmstauresolution} %\textit{Study of $\tau$-jet identification in CMS}, 
 R. Kinnunen, A.N. Nikitenko, \textbf{CMS NOTE} \href{http://cdsweb.cern.ch/record/687274}{1997/002}.
-\bibitem{bib:Frog} L. Quertenmont, V. Roberfroid, hep-ex/xxx.
-\bibitem{bib:wtphotoproduction} J. de Favereau de Jeneret, S. Ovyn, \textbf{Nucl. Phys. Proc. Suppl.} \href{http://dx.doi.org/10.1016/j.nuclphysbps.2008.07.040}{179-180 (2008)} \href{http://dx.doi.org/10.1016/j.nuclphysbps.2008.07.040}{277-284}; S. Ovyn, J. de Favereau de Jeneret, \href{http://dx.doi.org/10.1393/ncb/i2008-10684-5}{Nuovo Cimento B}, arXiv:hep-ph/0806.4841.
+\bibitem{bib:Frog} L. Quertenmont, V. Roberfroid, \textbf{CMS CR} \href{http://cms.cern.ch/iCMS/jsp/openfile.jsp?type=CR&year=2009&files=CR2009_028.pdf}{2009/028}, arXiv:\href{http://arxiv.org/abs/0901.2718}{0901.2718v1}[hep-ex].
+\bibitem{bib:wtphotoproduction} J. de Favereau de Jeneret, S. Ovyn, \textbf{Nucl. Phys. Proc. Suppl.} \href{http://dx.doi.org/10.1016/j.nuclphysbps.2008.07.040}{179-180 (2008)} \href{http://dx.doi.org/10.1016/j.nuclphysbps.2008.07.040}{277-284}; S. Ovyn, J. de Favereau de Jeneret, \href{http://dx.doi.org/10.1393/ncb/i2008-10684-5}{Nuovo Cimento B}, arXiv:0806.4841[hep-ph].
 
 \bibitem{bib:papierquisortirajamais}J. de Favereau~et~al, \textbf{CP3-08-04} (2008), to be published in EPJ.
 
-\bibitem{bib:papiersimon} il faut lui demander...
+\bibitem{bib:papiersimon} S. de Visscher, M. Herquet, to be published.
 
 \bibitem{bib:mcfio} P. Lebrun, L. Garren, Copyright (c) 1994-1995 Universities Research Association, Inc.