Index: /trunk/Makefile
===================================================================
--- /trunk/Makefile	(revision 213)
+++ /trunk/Makefile	(revision 214)
@@ -17,5 +17,5 @@
 
 #CXXFLAGS += $(ROOTCFLAGS) -DDROP_CGAL -Iinterface -IUtilities/CDFCones/interface -IUtilities/ExRootAnalysis/interface -IUtilities/mcfio -IUtilities/stdhep -IUtilities/Hector/include 
-CXXFLAGS += $(ROOTCFLAGS) -DDROP_CGAL -I. -IUtilities/mcfio -IUtilities/stdhep -IUtilities/Hector/include -IUtilities/CDFCones/interface -IExamples
+CXXFLAGS += $(ROOTCFLAGS) -DDROP_CGAL -I. -Iinterface -IUtilities/mcfio -IUtilities/stdhep -IUtilities/Hector/include -IUtilities/CDFCones/interface -IExamples -IUtilities/FROG/Includes/FROG -IUtilities/ExRootAnalysis/interface -IUtilities/Fastjet/include/fastjet -IUtilities/Fastjet/plugins/CDFCones -IUtilities/Fastjet/plugins/CDFCones/interface -IUtilities/Fastjet/plugins/SISCone 
 LIBS = $(ROOTLIBS) -lEG $(SYSLIBS)
 GLIBS = $(ROOTGLIBS) $(SYSLIBS)
@@ -36,36 +36,15 @@
 
 tmp/Delphes.$(ObjSuf): \
-	Delphes.cpp \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	interface/DataConverter.h \
-	interface/HEPEVTConverter.h \
-	interface/LHEFConverter.h \
-	interface/STDHEPConverter.h \
-	interface/SmearUtil.h \
-	interface/BFieldProp.h \
-	interface/TriggerUtil.h \
-	interface/VeryForward.h \
-	interface/JetUtils.h \
-	interface/FrogUtil.h
+	Delphes.cpp
 Resolutions$(ExeSuf): \
 	tmp/Resolutions.$(ObjSuf)
 
 tmp/Resolutions.$(ObjSuf): \
-	Resolutions.cpp \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	interface/DataConverter.h \
-	interface/HEPEVTConverter.h \
-	interface/LHEFConverter.h \
-	interface/STDHEPConverter.h \
-	interface/SmearUtil.h \
-	interface/JetUtils.h \
-	interface/BFieldProp.h \
-	Utilities/Fastjet/include/fastjet/PseudoJet.hh \
-	Utilities/Fastjet/include/fastjet/ClusterSequence.hh \
-	interface/TreeClasses.h
+	Resolutions.cpp
+testHector$(ExeSuf): \
+	tmp/testHector.$(ObjSuf)
+
+tmp/testHector.$(ObjSuf): \
+	testHector.cpp
 Analysis_Ex$(ExeSuf): \
 	tmp/Examples/Analysis_Ex.$(ObjSuf)
@@ -73,9 +52,4 @@
 tmp/Examples/Analysis_Ex.$(ObjSuf): \
 	Examples/Analysis_Ex.cpp \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
 	Examples/interface/Analysis_Ex.h
 Trigger_Only$(ExeSuf): \
@@ -83,20 +57,14 @@
 
 tmp/Examples/Trigger_Only.$(ObjSuf): \
-	Examples/Trigger_Only.cpp \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	interface/TriggerUtil.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h
+	Examples/Trigger_Only.cpp
 Frog_on_analysis_output$(ExeSuf): \
 	tmp/Examples/Frog_on_analysis_output.$(ObjSuf)
 
 tmp/Examples/Frog_on_analysis_output.$(ObjSuf): \
-	Examples/Frog_on_analysis_output.cpp \
-	interface/FrogUtil.h \
-	interface/SmearUtil.h
+	Examples/Frog_on_analysis_output.cpp
 EXECUTABLE =  \
 	Delphes$(ExeSuf) \
 	Resolutions$(ExeSuf) \
+	testHector$(ExeSuf) \
 	Analysis_Ex$(ExeSuf) \
 	Trigger_Only$(ExeSuf) \
@@ -106,4 +74,5 @@
 	tmp/Delphes.$(ObjSuf) \
 	tmp/Resolutions.$(ObjSuf) \
+	tmp/testHector.$(ObjSuf) \
 	tmp/Examples/Analysis_Ex.$(ObjSuf) \
 	tmp/Examples/Trigger_Only.$(ObjSuf) \
@@ -129,76 +98,34 @@
 	tmp/Examples/src/Analysis_ExDict.$(ObjSuf)
 
-tmp/src/JetUtils.$(ObjSuf): \
-	src/JetUtils.$(SrcSuf) \
-	interface/JetUtils.h
+tmp/src/JetsUtil.$(ObjSuf): \
+	src/JetsUtil.$(SrcSuf)
 tmp/src/SmearUtil.$(ObjSuf): \
-	src/SmearUtil.$(SrcSuf) \
-	interface/SmearUtil.h
+	src/SmearUtil.$(SrcSuf)
 tmp/src/TriggerUtil.$(ObjSuf): \
-	src/TriggerUtil.$(SrcSuf) \
-	interface/TriggerUtil.h
+	src/TriggerUtil.$(SrcSuf)
 tmp/src/BFieldProp.$(ObjSuf): \
-	src/BFieldProp.$(SrcSuf) \
-	interface/BFieldProp.h
+	src/BFieldProp.$(SrcSuf)
 tmp/src/VeryForward.$(ObjSuf): \
-	src/VeryForward.$(SrcSuf) \
-	interface/VeryForward.h \
-	interface/SmearUtil.h
+	src/VeryForward.$(SrcSuf)
 tmp/src/LHEFConverter.$(ObjSuf): \
-	src/LHEFConverter.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	interface/LHEFConverter.h \
-	Utilities/ExRootAnalysis/interface/LHEF.h
+	src/LHEFConverter.$(SrcSuf)
 tmp/src/FrogUtil.$(ObjSuf): \
-	src/FrogUtil.$(SrcSuf) \
-	interface/FrogUtil.h \
-	Utilities/FROG/Includes/FROG/FROG_DetId.h \
-	Utilities/FROG/Includes/FROG/FROG_Geometry.h \
-	Utilities/FROG/Includes/FROG/FROG_Events.h \
-	Utilities/FROG/Includes/FROG/FROG_Element_Tools.h \
-	Utilities/FROG/Includes/FROG/FROG_Net_Tools.h \
-	Utilities/FROG/Includes/FROG/FROG_Path.h \
-	Utilities/FROG/Includes/FROG/FROG_Coord.h \
-	Utilities/FROG/Includes/FROG/FROG_ReadCards.h \
-	Utilities/FROG/Includes/FROG/FROG_ZLib.h
+	src/FrogUtil.$(SrcSuf)
 tmp/src/STDHEPConverter.$(ObjSuf): \
-	src/STDHEPConverter.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/ExRootAnalysis/interface/LHEF.h \
-	Utilities/stdhep/stdhep_mcfio.h \
-	Utilities/stdhep/stdhep_declarations.h \
-	interface/STDHEPConverter.h
+	src/STDHEPConverter.$(SrcSuf)
 tmp/src/HEPEVTConverter.$(ObjSuf): \
-	src/HEPEVTConverter.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	interface/HEPEVTConverter.h
+	src/HEPEVTConverter.$(SrcSuf)
 tmp/src/TreeClasses.$(ObjSuf): \
-	src/TreeClasses.$(SrcSuf) \
-	interface/TreeClasses.h
+	src/TreeClasses.$(SrcSuf)
 tmp/Utilities/ExRootAnalysis/src/ExRootTreeReader.$(ObjSuf): \
-	Utilities/ExRootAnalysis/src/ExRootTreeReader.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h
+	Utilities/ExRootAnalysis/src/ExRootTreeReader.$(SrcSuf)
 tmp/Utilities/ExRootAnalysis/src/ExRootTreeBranch.$(ObjSuf): \
-	Utilities/ExRootAnalysis/src/ExRootTreeBranch.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h
+	Utilities/ExRootAnalysis/src/ExRootTreeBranch.$(SrcSuf)
 tmp/Utilities/ExRootAnalysis/src/ExRootProgressBar.$(ObjSuf): \
-	Utilities/ExRootAnalysis/src/ExRootProgressBar.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/ExRootProgressBar.h
+	Utilities/ExRootAnalysis/src/ExRootProgressBar.$(SrcSuf)
 tmp/Utilities/ExRootAnalysis/src/ExRootTreeWriter.$(ObjSuf): \
-	Utilities/ExRootAnalysis/src/ExRootTreeWriter.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h
+	Utilities/ExRootAnalysis/src/ExRootTreeWriter.$(SrcSuf)
 tmp/Utilities/ExRootAnalysis/src/BlockClasses.$(ObjSuf): \
-	Utilities/ExRootAnalysis/src/BlockClasses.$(SrcSuf) \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/BlockCompare.h
+	Utilities/ExRootAnalysis/src/BlockClasses.$(SrcSuf)
 tmp/Utilities/Hector/src/H_Kicker.$(ObjSuf): \
 	Utilities/Hector/src/H_Kicker.$(SrcSuf)
@@ -363,5 +290,5 @@
 	Examples/interface/Analysis_Ex.h
 SOURCE_OBJ =  \
-	tmp/src/JetUtils.$(ObjSuf) \
+	tmp/src/JetsUtil.$(ObjSuf) \
 	tmp/src/SmearUtil.$(ObjSuf) \
 	tmp/src/TriggerUtil.$(ObjSuf) \
@@ -544,79 +471,4 @@
 	tmp/Utilities/stdhep/stdhep_internal_utils.$(ObjSuf)
 
-interface/TriggerUtil.h: \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h
-	@touch $@
-
-interface/DataConverter.h: \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/ExRootAnalysis/interface/LHEF.h
-	@touch $@
-
-Utilities/Fastjet/include/fastjet/Error.hh: \
-	Utilities/Fastjet/include/fastjet/internal/base.hh
-	@touch $@
-
-interface/STDHEPConverter.h: \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
-	Utilities/ExRootAnalysis/interface/LHEF.h \
-	interface/DataConverter.h
-	@touch $@
-
-Utilities/ExRootAnalysis/interface/BlockClasses.h: \
-	Utilities/ExRootAnalysis/interface/BlockCompare.h
-	@touch $@
-
-Utilities/Fastjet/include/fastjet/PseudoJet.hh: \
-	Utilities/Fastjet/include/fastjet/internal/numconsts.hh
-	@touch $@
-
-interface/HEPEVTConverter.h: \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
-	interface/DataConverter.h
-	@touch $@
-
-interface/FrogUtil.h: \
-	interface/SmearUtil.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/FROG/Includes/FROG/FROG_Events.h
-	@touch $@
-
-interface/TreeClasses.h: \
-	Utilities/ExRootAnalysis/interface/BlockCompare.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h
-	@touch $@
-
-interface/LHEFConverter.h: \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/ExRootAnalysis/interface/LHEF.h \
-	interface/DataConverter.h
-	@touch $@
-
-interface/JetUtils.h: \
-	interface/SmearUtil.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/Fastjet/plugins/CDFCones/interface/PhysicsTower.hh \
-	Utilities/Fastjet/include/fastjet/PseudoJet.hh \
-	Utilities/Fastjet/include/fastjet/ClusterSequence.hh \
-	Utilities/Fastjet/include/fastjet/config.h
-	@touch $@
-
-interface/SmearUtil.h: \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
-	Utilities/Fastjet/plugins/CDFCones/interface/PhysicsTower.hh
-	@touch $@
-
 Examples/interface/Analysis_Ex.h: \
 	Utilities/ExRootAnalysis/interface/ExRootTreeReader.h \
@@ -627,29 +479,11 @@
 	@touch $@
 
-interface/BFieldProp.h: \
-	interface/SmearUtil.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h
+interface/TreeClasses.h: \
+	Utilities/ExRootAnalysis/interface/BlockCompare.h \
+	Utilities/ExRootAnalysis/interface/BlockClasses.h
 	@touch $@
 
-Utilities/stdhep/stdhep_declarations.h: \
-	Utilities/stdhep/stdhep.h \
-	Utilities/stdhep/hepev4.h \
-	Utilities/stdhep/hepeup.h \
-	Utilities/stdhep/heprup.h \
-	Utilities/stdhep/stdtmp.h \
-	Utilities/stdhep/stdhd.h \
-	Utilities/stdhep/stdcnt.h \
-	Utilities/stdhep/stdcm1.h \
-	Utilities/stdhep/stdver.h
-	@touch $@
-
-interface/VeryForward.h: \
-	interface/SmearUtil.h \
-	Utilities/ExRootAnalysis/interface/BlockClasses.h \
-	Utilities/ExRootAnalysis/interface/TSimpleArray.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h \
-	Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h \
-	Utilities/Fastjet/plugins/CDFCones/interface/PhysicsTower.hh
+Utilities/Fastjet/include/fastjet/Error.hh: \
+	Utilities/Fastjet/include/fastjet/internal/base.hh
 	@touch $@
 
Index: /trunk/genMakefile.tcl
===================================================================
--- /trunk/genMakefile.tcl	(revision 213)
+++ /trunk/genMakefile.tcl	(revision 214)
@@ -218,5 +218,5 @@
 
 #CXXFLAGS += $(ROOTCFLAGS) -DDROP_CGAL -Iinterface -IUtilities/CDFCones/interface -IUtilities/ExRootAnalysis/interface -IUtilities/mcfio -IUtilities/stdhep -IUtilities/Hector/include 
-CXXFLAGS += $(ROOTCFLAGS) -DDROP_CGAL -I. -IUtilities/mcfio -IUtilities/stdhep -IUtilities/Hector/include -IUtilities/CDFCones/interface -IExamples
+CXXFLAGS += $(ROOTCFLAGS) -DDROP_CGAL -I. -Iinterface -IUtilities/mcfio -IUtilities/stdhep -IUtilities/Hector/include -IUtilities/CDFCones/interface -IExamples -IUtilities/FROG/Includes/FROG -IUtilities/ExRootAnalysis/interface -IUtilities/Fastjet/include/fastjet -IUtilities/Fastjet/plugins/CDFCones -IUtilities/Fastjet/plugins/CDFCones/interface -IUtilities/Fastjet/plugins/SISCone 
 LIBS = $(ROOTLIBS) -lEG $(SYSLIBS)
 GLIBS = $(ROOTGLIBS) $(SYSLIBS)